package thyyxxk.webserver.service.hutoolcache;

import cn.hutool.cache.Cache;
import cn.hutool.cache.CacheUtil;
import cn.hutool.core.util.StrUtil;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import thyyxxk.webserver.dao.his.hutoolcache.HutoolCacheDao;

import java.util.List;

@Service
public class CountryCache implements HutoolCacheInterface<CountryCache.Country> {
    private final HutoolCacheDao dao;
    private static final int CACHE_SIZE = 32;
    Cache<String, Country> cache = CacheUtil.newLFUCache(CACHE_SIZE);

    @Data
    public static class Country {
        private String code;
        private String name;
        private String pyCode;
        private String siCode;
    }

    @Autowired
    public CountryCache(HutoolCacheDao dao) {
        this.dao = dao;
    }

    @Override
    public void put(String key, Country value) {
        if (value != null) {
            cache.put(key, value);
        }
    }

    @Override
    public Country get(String key) {
        if (StrUtil.isBlank(key)) {
            return new Country();
        }

        Country country = cache.get(key);
        if (country == null) {
            country = dbInfo(key);
            put(key, country);
        }
        return country;
    }

    @Override
    public void del(String key) {
        cache.remove(key);
    }

    @Override
    public void clear() {
        cache.clear();
    }

    public Country dbInfo(String key) {
        return dao.selectCountry(key);
    }

    public String getCountryName(String code) {
        Country country = get(code);
        if (country != null) {
            return country.getName();
        }
        return null;
    }

    @Override
    public List<CacheAll> getAll() {
        return this.getAllUtils(cache.cacheObjIterator());
    }

    @Override
    public void refreshCache(String key) {
        put(key, dbInfo(key));
    }

    @Override
    public String getLabel() {
        return "国家";
    }
}
